diff --git a/pki/base/common/src/com/netscape/cms/profile/def/CertificatePoliciesExtDefault.java b/pki/base/common/src/com/netscape/cms/profile/def/CertificatePoliciesExtDefault.java
index 6668ee82338a02bebd1081fdaa4f03d8640c6d02..8d4ae228883fbeee00d2ef4f5938e43e1f70d5aa 100644
--- a/pki/base/common/src/com/netscape/cms/profile/def/CertificatePoliciesExtDefault.java
+++ b/pki/base/common/src/com/netscape/cms/profile/def/CertificatePoliciesExtDefault.java
@@ -146,7 +146,7 @@ public class CertificatePoliciesExtDefault extends EnrollExtDefault {
         super.setConfig(name, value);
     }
 
-    public Enumeration getConfigNames() {
+    public Enumeration<String> getConfigNames() {
         refreshConfigAndValueNames();
         return super.getConfigNames();
     }
@@ -172,8 +172,8 @@ public class CertificatePoliciesExtDefault extends EnrollExtDefault {
                 addConfigName(CONFIG_PREFIX + i + SEPARATOR + CONFIG_PREFIX1 + j + SEPARATOR + CONFIG_USERNOTICE_ENABLE);
                 addConfigName(CONFIG_PREFIX + i + SEPARATOR + CONFIG_PREFIX1 + j + SEPARATOR + CONFIG_CPSURI_VALUE);
                 addConfigName(CONFIG_PREFIX + i + SEPARATOR + CONFIG_PREFIX1 + j + SEPARATOR + CONFIG_USERNOTICE_ORG);
-                addConfigName(CONFIG_PREFIX + i + SEPARATOR + CONFIG_PREFIX1 + j + SEPARATOR
-                        + CONFIG_USERNOTICE_NUMBERS);
+                addConfigName(CONFIG_PREFIX
+                        + i + SEPARATOR + CONFIG_PREFIX1 + j + SEPARATOR + CONFIG_USERNOTICE_NUMBERS);
                 addConfigName(CONFIG_PREFIX + i + SEPARATOR + CONFIG_PREFIX1 + j + SEPARATOR + CONFIG_USERNOTICE_TEXT);
             }
         }
@@ -243,9 +243,9 @@ public class CertificatePoliciesExtDefault extends EnrollExtDefault {
         return null;
     }
 
-    private Hashtable buildRecords(String value) throws EPropertyException {
+    private Hashtable<String, String> buildRecords(String value) throws EPropertyException {
         StringTokenizer st = new StringTokenizer(value, "\r\n");
-        Hashtable table = new Hashtable();
+        Hashtable<String, String> table = new Hashtable<String, String>();
         while (st.hasMoreTokens()) {
             String token = (String) st.nextToken();
             int index = token.indexOf(":");
@@ -285,12 +285,12 @@ public class CertificatePoliciesExtDefault extends EnrollExtDefault {
                         getExtension(PKIXExtensions.CertificatePolicies_Id.toString(),
                                 info);
 
-                Hashtable h = buildRecords(value);
+                Hashtable<String, String> h = buildRecords(value);
 
                 String numStr = (String) h.get(CONFIG_POLICY_NUM);
                 int size = Integer.parseInt(numStr);
 
-                Vector certificatePolicies = new Vector();
+                Vector<CertificatePolicyInfo> certificatePolicies = new Vector<CertificatePolicyInfo>();
                 for (int i = 0; i < size; i++) {
                     String enable = (String) h.get(CONFIG_PREFIX + i + SEPARATOR + CONFIG_POLICY_ENABLE);
                     CertificatePolicyInfo cinfo = null;
@@ -302,30 +302,41 @@ public class CertificatePoliciesExtDefault extends EnrollExtDefault {
                                         locale, "CMS_PROFILE_CERTIFICATE_POLICIES_EMPTY_POLICYID"));
                         CertificatePolicyId cpolicyId = getPolicyId(policyId);
 
-                        String qualifersNum = (String) h.get(CONFIG_PREFIX + i + SEPARATOR
-                                + CONFIG_POLICY_QUALIFIERS_NUM);
+                        String qualifersNum =
+                                (String) h.get(CONFIG_PREFIX + i + SEPARATOR + CONFIG_POLICY_QUALIFIERS_NUM);
                         PolicyQualifiers policyQualifiers = new PolicyQualifiers();
                         int num = 0;
                         if (qualifersNum != null && qualifersNum.length() > 0)
                             num = Integer.parseInt(qualifersNum);
                         for (int j = 0; j < num; j++) {
-                            String cpsuriEnable = (String) h.get(CONFIG_PREFIX + i + SEPARATOR + CONFIG_PREFIX1 + j
-                                    + SEPARATOR + CONFIG_CPSURI_ENABLE);
-                            String usernoticeEnable = (String) h.get(CONFIG_PREFIX + i + SEPARATOR + CONFIG_PREFIX1 + j
-                                    + SEPARATOR + CONFIG_USERNOTICE_ENABLE);
+                            String cpsuriEnable =
+                                    (String) h.get(CONFIG_PREFIX
+                                            + i + SEPARATOR + CONFIG_PREFIX1 + j + SEPARATOR + CONFIG_CPSURI_ENABLE);
+                            String usernoticeEnable =
+                                    (String) h
+                                            .get(CONFIG_PREFIX
+                                                    + i + SEPARATOR + CONFIG_PREFIX1 + j + SEPARATOR
+                                                    + CONFIG_USERNOTICE_ENABLE);
                             if (cpsuriEnable != null && cpsuriEnable.equals("true")) {
-                                String cpsuri = (String) h.get(CONFIG_PREFIX + i + SEPARATOR + CONFIG_PREFIX1 + j
-                                        + SEPARATOR + CONFIG_CPSURI_VALUE);
+                                String cpsuri =
+                                        (String) h.get(CONFIG_PREFIX
+                                                + i + SEPARATOR + CONFIG_PREFIX1 + j + SEPARATOR + CONFIG_CPSURI_VALUE);
                                 netscape.security.x509.PolicyQualifierInfo qualifierInfo = createCPSuri(cpsuri);
                                 if (qualifierInfo != null)
                                     policyQualifiers.add(qualifierInfo);
                             } else if (usernoticeEnable != null && enable.equals("true")) {
-                                String org = (String) h.get(CONFIG_PREFIX + i + SEPARATOR + CONFIG_PREFIX1 + j
-                                        + SEPARATOR + CONFIG_USERNOTICE_ORG);
-                                String noticenumbers = (String) h.get(CONFIG_PREFIX + i + SEPARATOR + CONFIG_PREFIX1
-                                        + j + SEPARATOR + CONFIG_USERNOTICE_NUMBERS);
-                                String explicitText = (String) h.get(CONFIG_PREFIX + i + SEPARATOR + CONFIG_PREFIX1 + j
-                                        + SEPARATOR + CONFIG_USERNOTICE_TEXT);
+                                String org =
+                                        (String) h.get(CONFIG_PREFIX
+                                                + i + SEPARATOR + CONFIG_PREFIX1 + j + SEPARATOR
+                                                + CONFIG_USERNOTICE_ORG);
+                                String noticenumbers =
+                                        (String) h.get(CONFIG_PREFIX
+                                                + i + SEPARATOR + CONFIG_PREFIX1 + j + SEPARATOR
+                                                + CONFIG_USERNOTICE_NUMBERS);
+                                String explicitText =
+                                        (String) h.get(CONFIG_PREFIX
+                                                + i + SEPARATOR + CONFIG_PREFIX1 + j + SEPARATOR
+                                                + CONFIG_USERNOTICE_TEXT);
                                 netscape.security.x509.PolicyQualifierInfo qualifierInfo = createUserNotice(org,
                                         noticenumbers, explicitText);
                                 if (qualifierInfo != null)
@@ -364,6 +375,7 @@ public class CertificatePoliciesExtDefault extends EnrollExtDefault {
         }
     }
 
+    @SuppressWarnings("unchecked")
     public String getValue(String name, Locale locale,
             X509CertInfo info)
             throws EPropertyException {
@@ -397,17 +409,17 @@ public class CertificatePoliciesExtDefault extends EnrollExtDefault {
 
             StringBuffer sb = new StringBuffer();
             int num_policies = getNumPolicies();
-            int num_qualifiers = DEF_NUM_QUALIFIERS;
             sb.append(CONFIG_POLICY_NUM);
             sb.append(":");
             sb.append(num_policies);
             sb.append("\n");
-            Vector infos = null;
+            Vector<CertificatePolicyInfo> infos;
+
             try {
-                infos = (Vector) (ext.get(CertificatePoliciesExtension.INFOS));
+                infos = (Vector<CertificatePolicyInfo>) ext.get(CertificatePoliciesExtension.INFOS);
             } catch (IOException ee) {
+                infos = null;
             }
-            Enumeration policies = ext.getElements();
 
             for (int i = 0; i < num_policies; i++) {
                 int qSize = 0;
@@ -416,7 +428,7 @@ public class CertificatePoliciesExtDefault extends EnrollExtDefault {
                 PolicyQualifiers qualifiers = null;
                 if (infos.size() > 0) {
                     CertificatePolicyInfo cinfo =
-                            (CertificatePolicyInfo) infos.elementAt(0);
+                            infos.elementAt(0);
 
                     CertificatePolicyId id1 = cinfo.getPolicyIdentifier();
                     policyId = id1.getIdentifier().toString();
@@ -455,8 +467,8 @@ public class CertificatePoliciesExtDefault extends EnrollExtDefault {
                     sb.append(":");
                     sb.append("");
                     sb.append("\n");
-                    sb.append(CONFIG_PREFIX + i + SEPARATOR + CONFIG_PREFIX1 + "0" + SEPARATOR
-                            + CONFIG_USERNOTICE_ENABLE);
+                    sb.append(CONFIG_PREFIX
+                            + i + SEPARATOR + CONFIG_PREFIX1 + "0" + SEPARATOR + CONFIG_USERNOTICE_ENABLE);
                     sb.append(":");
                     sb.append("false");
                     sb.append("\n");
@@ -464,8 +476,8 @@ public class CertificatePoliciesExtDefault extends EnrollExtDefault {
                     sb.append(":");
                     sb.append("");
                     sb.append("\n");
-                    sb.append(CONFIG_PREFIX + i + SEPARATOR + CONFIG_PREFIX1 + "0" + SEPARATOR
-                            + CONFIG_USERNOTICE_NUMBERS);
+                    sb.append(CONFIG_PREFIX
+                            + i + SEPARATOR + CONFIG_PREFIX1 + "0" + SEPARATOR + CONFIG_USERNOTICE_NUMBERS);
                     sb.append(":");
                     sb.append("");
                     sb.append("\n");
@@ -527,8 +539,8 @@ public class CertificatePoliciesExtDefault extends EnrollExtDefault {
                     sb.append(":");
                     sb.append(org);
                     sb.append("\n");
-                    sb.append(CONFIG_PREFIX + i + SEPARATOR + CONFIG_PREFIX1 + j + SEPARATOR
-                            + CONFIG_USERNOTICE_NUMBERS);
+                    sb.append(CONFIG_PREFIX
+                            + i + SEPARATOR + CONFIG_PREFIX1 + j + SEPARATOR + CONFIG_USERNOTICE_NUMBERS);
                     sb.append(":");
                     sb.append(noticeNum.toString());
                     sb.append("\n");
@@ -547,7 +559,6 @@ public class CertificatePoliciesExtDefault extends EnrollExtDefault {
 
     public String getText(Locale locale) {
         StringBuffer sb = new StringBuffer();
-        String numPolicies = getConfig(CONFIG_POLICY_NUM);
         int num = getNumPolicies();
         int num1 = getNumQualifiers();
 
@@ -630,7 +641,7 @@ public class CertificatePoliciesExtDefault extends EnrollExtDefault {
 
         try {
             boolean critical = getConfigBoolean(CONFIG_CRITICAL);
-            Vector certificatePolicies = new Vector();
+            Vector<CertificatePolicyInfo> certificatePolicies = new Vector<CertificatePolicyInfo>();
             int num = getNumPolicies();
             CMS.debug("CertificatePoliciesExtension: createExtension: number of policies=" + num);
             IConfigStore config = getConfigStore();
@@ -644,8 +655,8 @@ public class CertificatePoliciesExtDefault extends EnrollExtDefault {
                 if (enable != null && enable.equals("true")) {
                     String policyId = substore.getString(CONFIG_POLICY_ID);
                     CertificatePolicyId cpolicyId = getPolicyId(policyId);
-                    CMS.debug("CertificatePoliciesExtension: createExtension: CertificatePolicy " + i + " policyId="
-                            + policyId);
+                    CMS.debug("CertificatePoliciesExtension: createExtension: CertificatePolicy "
+                            + i + " policyId=" + policyId);
                     int qualifierNum = getNumQualifiers();
                     PolicyQualifiers policyQualifiers = new PolicyQualifiers();
                     for (int j = 0; j < qualifierNum; j++) {
@@ -741,7 +752,7 @@ public class CertificatePoliciesExtDefault extends EnrollExtDefault {
 
         int nums[] = null;
         if (noticeNums != null && noticeNums.length() > 0) {
-            Vector numsVector = new Vector();
+            Vector<String> numsVector = new Vector<String>();
             StringTokenizer tokens = new StringTokenizer(noticeNums, ";");
             while (tokens.hasMoreTokens()) {
                 String num = tokens.nextToken().trim();
diff --git a/pki/base/common/src/com/netscape/cms/profile/def/EnrollDefault.java b/pki/base/common/src/com/netscape/cms/profile/def/EnrollDefault.java
index 060f2ad16dc3cde176f3beb09a55d060f21e1372..855cd92c7eb538f5e23ba21ddea363ca006bd818 100644
--- a/pki/base/common/src/com/netscape/cms/profile/def/EnrollDefault.java
+++ b/pki/base/common/src/com/netscape/cms/profile/def/EnrollDefault.java
@@ -289,10 +289,10 @@ public abstract class EnrollDefault implements IPolicyDefault, ICertInfoPolicyDe
                     info.get(X509CertInfo.EXTENSIONS);
             if (exts == null)
                 return;
-            Enumeration<?> e = exts.getNames();
+            Enumeration<String> e = exts.getNames();
 
             while (e.hasMoreElements()) {
-                String n = (String) e.nextElement();
+                String n = e.nextElement();
                 Extension ext = (Extension) exts.get(n);
 
                 if (ext.getExtensionId().toString().equals(name)) {
@@ -321,10 +321,10 @@ public abstract class EnrollDefault implements IPolicyDefault, ICertInfoPolicyDe
     protected Extension getExtension(String name, CertificateExtensions exts) {
         if (exts == null)
             return null;
-        Enumeration<?> e = exts.getElements();
+        Enumeration<Extension> e = exts.getAttributes();
 
         while (e.hasMoreElements()) {
-            Extension ext = (Extension) e.nextElement();
+            Extension ext = e.nextElement();
 
             if (ext.getExtensionId().toString().equals(name)) {
                 return ext;
@@ -632,19 +632,19 @@ public abstract class EnrollDefault implements IPolicyDefault, ICertInfoPolicyDe
         return true;
     }
 
-    protected String buildRecords(Vector<?> recs) throws EPropertyException {
+    protected String buildRecords(Vector<NameValuePairs> recs) throws EPropertyException {
         StringBuffer sb = new StringBuffer();
 
         for (int i = 0; i < recs.size(); i++) {
-            NameValuePairs pairs = (NameValuePairs) recs.elementAt(i);
+            NameValuePairs pairs = recs.elementAt(i);
 
             sb.append("Record #");
             sb.append(i);
             sb.append("\r\n");
-            Enumeration<?> e = pairs.getNames();
+            Enumeration<String> e = pairs.getNames();
 
             while (e.hasMoreElements()) {
-                String key = (String) e.nextElement();
+                String key = e.nextElement();
                 String val = pairs.getValue(key);
 
                 sb.append(key);
@@ -665,14 +665,14 @@ public abstract class EnrollDefault implements IPolicyDefault, ICertInfoPolicyDe
         NameValuePairs nvps = null;
 
         while (st.hasMoreTokens()) {
-            String token = (String) st.nextToken();
+            String token = st.nextToken();
 
             if (token.equals("Record #" + num)) {
                 CMS.debug("parseRecords: Record" + num);
                 nvps = new NameValuePairs();
                 v.addElement(nvps);
                 try {
-                    token = (String) st.nextToken();
+                    token = st.nextToken();
                 } catch (NoSuchElementException e) {
                     v.removeElementAt(num);
                     CMS.debug(e.toString());
@@ -756,7 +756,7 @@ public abstract class EnrollDefault implements IPolicyDefault, ICertInfoPolicyDe
         return locale;
     }
 
-    public String toGeneralNameString(GeneralName gn) {
+    public String toGeneralNameString(GeneralNameInterface gn) {
         int type = gn.getType();
         // Sun's General Name is not consistent, so we need
         // to do a special case for directory string
diff --git a/pki/base/common/src/com/netscape/cms/profile/def/FreshestCRLExtDefault.java b/pki/base/common/src/com/netscape/cms/profile/def/FreshestCRLExtDefault.java
index 3dcf899291e9dec590b20967900b7aae98611e94..d5ac9247dc96e3384d67b677a79ffa36677eb7ee 100644
--- a/pki/base/common/src/com/netscape/cms/profile/def/FreshestCRLExtDefault.java
+++ b/pki/base/common/src/com/netscape/cms/profile/def/FreshestCRLExtDefault.java
@@ -119,7 +119,7 @@ public class FreshestCRLExtDefault extends EnrollExtDefault {
         super.setConfig(name, value);
     }
 
-    public Enumeration getConfigNames() {
+    public Enumeration<String> getConfigNames() {
         refreshConfigAndValueNames();
         return super.getConfigNames();
     }
@@ -224,7 +224,7 @@ public class FreshestCRLExtDefault extends EnrollExtDefault {
                         getExtension(FreshestCRLExtension.OID,
                                 info);
 
-                Vector v = parseRecords(value);
+                Vector<NameValuePairs> v = parseRecords(value);
                 int size = v.size();
 
                 boolean critical = ext.isCritical();
@@ -232,7 +232,7 @@ public class FreshestCRLExtDefault extends EnrollExtDefault {
 
                 for (; i < size; i++) {
                     NameValuePairs nvps = (NameValuePairs) v.elementAt(i);
-                    Enumeration names = nvps.getNames();
+                    Enumeration<String> names = nvps.getNames();
                     String pointType = null;
                     String pointValue = null;
                     String issuerType = null;
@@ -384,7 +384,7 @@ public class FreshestCRLExtDefault extends EnrollExtDefault {
 
             StringBuffer sb = new StringBuffer();
 
-            Vector recs = new Vector();
+            Vector<NameValuePairs> recs = new Vector<NameValuePairs>();
             int num = getNumPoints();
             for (int i = 0; i < num; i++) {
                 NameValuePairs pairs = null;
diff --git a/pki/base/common/src/com/netscape/cms/profile/def/IssuerAltNameExtDefault.java b/pki/base/common/src/com/netscape/cms/profile/def/IssuerAltNameExtDefault.java
index d56eebc02cfb6a4389d3f2192c714cdd10716ed7..251d8a3e7aae34dc61e92d4e8703d6c31b1b65a9 100644
--- a/pki/base/common/src/com/netscape/cms/profile/def/IssuerAltNameExtDefault.java
+++ b/pki/base/common/src/com/netscape/cms/profile/def/IssuerAltNameExtDefault.java
@@ -235,7 +235,7 @@ public class IssuerAltNameExtDefault extends EnrollExtDefault {
                 GeneralNames names = (GeneralNames)
                         ext.get(IssuerAlternativeNameExtension.ISSUER_NAME);
                 StringBuffer sb = new StringBuffer();
-                Enumeration e = names.elements();
+                Enumeration<GeneralNameInterface> e = names.elements();
 
                 while (e.hasMoreElements()) {
                     GeneralName gn = (GeneralName) e.nextElement();
diff --git a/pki/base/common/src/com/netscape/cms/profile/def/NameConstraintsExtDefault.java b/pki/base/common/src/com/netscape/cms/profile/def/NameConstraintsExtDefault.java
index 45db3576796f3a0dbf43150fc695371ae6552510..c513c332ba4fa380499bbd04756cd2c0f95ce494 100644
--- a/pki/base/common/src/com/netscape/cms/profile/def/NameConstraintsExtDefault.java
+++ b/pki/base/common/src/com/netscape/cms/profile/def/NameConstraintsExtDefault.java
@@ -315,9 +315,9 @@ public class NameConstraintsExtDefault extends EnrollExtDefault {
                     return;
                 }
 
-                Vector v = parseRecords(value);
+                Vector<NameValuePairs> v = parseRecords(value);
 
-                Vector permittedSubtrees = createSubtrees(locale, v);
+                Vector<GeneralSubtree> permittedSubtrees = createSubtrees(locale, v);
 
                 ext.set(NameConstraintsExtension.PERMITTED_SUBTREES,
                         new GeneralSubtrees(permittedSubtrees));
@@ -333,9 +333,9 @@ public class NameConstraintsExtDefault extends EnrollExtDefault {
                               "blank value for excluded subtrees ... returning");
                     return;
                 }
-                Vector v = parseRecords(value);
+                Vector<NameValuePairs> v = parseRecords(value);
 
-                Vector excludedSubtrees = createSubtrees(locale, v);
+                Vector<GeneralSubtree> excludedSubtrees = createSubtrees(locale, v);
 
                 ext.set(NameConstraintsExtension.EXCLUDED_SUBTREES,
                         new GeneralSubtrees(excludedSubtrees));
@@ -356,18 +356,18 @@ public class NameConstraintsExtDefault extends EnrollExtDefault {
         }
     }
 
-    private Vector createSubtrees(Locale locale, Vector v) throws EPropertyException {
+    private Vector<GeneralSubtree> createSubtrees(Locale locale, Vector<NameValuePairs> v) throws EPropertyException {
         int size = v.size();
         String choice = null;
         String val = "";
         String minS = null;
         String maxS = null;
 
-        Vector subtrees = new Vector();
+        Vector<GeneralSubtree> subtrees = new Vector<GeneralSubtree>();
 
         for (int i = 0; i < size; i++) {
             NameValuePairs nvps = (NameValuePairs) v.elementAt(i);
-            Enumeration names = nvps.getNames();
+            Enumeration<String> names = nvps.getNames();
 
             while (names.hasMoreElements()) {
                 String name1 = (String) names.nextElement();
@@ -512,10 +512,10 @@ public class NameConstraintsExtDefault extends EnrollExtDefault {
 
     private String getSubtreesInfo(NameConstraintsExtension ext,
             GeneralSubtrees subtrees) throws EPropertyException {
-        Vector trees = subtrees.getSubtrees();
+        Vector<GeneralSubtree> trees = subtrees.getSubtrees();
         int size = trees.size();
 
-        Vector recs = new Vector();
+        Vector<NameValuePairs> recs = new Vector<NameValuePairs>();
 
         for (int i = 0; i < size; i++) {
             GeneralSubtree tree = (GeneralSubtree) trees.elementAt(i);
@@ -601,7 +601,7 @@ public class NameConstraintsExtDefault extends EnrollExtDefault {
 
             boolean critical = getConfigBoolean(CONFIG_CRITICAL);
 
-            Vector v = new Vector();
+            Vector<GeneralSubtree> v = new Vector<GeneralSubtree>();
 
             for (int i = 0; i < num; i++) {
                 String enable = getConfig(CONFIG_PERMITTED_ENABLE + i);
@@ -616,7 +616,7 @@ public class NameConstraintsExtDefault extends EnrollExtDefault {
                 }
             }
 
-            Vector v1 = new Vector();
+            Vector<GeneralSubtree> v1 = new Vector<GeneralSubtree>();
 
             num = getNumExcluded();
             for (int i = 0; i < num; i++) {
diff --git a/pki/base/common/src/com/netscape/cms/profile/def/PolicyMappingsExtDefault.java b/pki/base/common/src/com/netscape/cms/profile/def/PolicyMappingsExtDefault.java
index f8fcfe15a1e309b2d6ebfd56cc9aabdbb3c2a3d1..183ef87bc0c57542d14db725b56753652a3f3272 100644
--- a/pki/base/common/src/com/netscape/cms/profile/def/PolicyMappingsExtDefault.java
+++ b/pki/base/common/src/com/netscape/cms/profile/def/PolicyMappingsExtDefault.java
@@ -108,7 +108,7 @@ public class PolicyMappingsExtDefault extends EnrollExtDefault {
         super.setConfig(name, value);
     }
 
-    public Enumeration getConfigNames() {
+    public Enumeration<String> getConfigNames() {
         refreshConfigAndValueNames();
         return super.getConfigNames();
     }
@@ -207,17 +207,17 @@ public class PolicyMappingsExtDefault extends EnrollExtDefault {
                 if (ext == null) {
                     return;
                 }
-                Vector v = parseRecords(value);
+                Vector<NameValuePairs> v = parseRecords(value);
                 int size = v.size();
 
                 String issuerPolicyId = null;
                 String subjectPolicyId = null;
                 String enable = null;
-                Vector policyMaps = new Vector();
+                Vector<CertificatePolicyMap> policyMaps = new Vector<CertificatePolicyMap>();
 
                 for (int i = 0; i < size; i++) {
                     NameValuePairs nvps = (NameValuePairs) v.elementAt(i);
-                    Enumeration names = nvps.getNames();
+                    Enumeration<String> names = nvps.getNames();
 
                     while (names.hasMoreElements()) {
                         String name1 = (String) names.nextElement();
@@ -310,12 +310,12 @@ public class PolicyMappingsExtDefault extends EnrollExtDefault {
 
             int num_mappings = getNumMappings();
 
-            Enumeration maps = ext.getMappings();
+            Enumeration<CertificatePolicyMap> maps = ext.getMappings();
 
             int num = 0;
             StringBuffer sb = new StringBuffer();
 
-            Vector recs = new Vector();
+            Vector<NameValuePairs> recs = new Vector<NameValuePairs>();
 
             for (int i = 0; i < num_mappings; i++) {
                 NameValuePairs pairs = new NameValuePairs();
@@ -388,7 +388,7 @@ public class PolicyMappingsExtDefault extends EnrollExtDefault {
 
         try {
             boolean critical = getConfigBoolean(CONFIG_CRITICAL);
-            Vector policyMaps = new Vector();
+            Vector<CertificatePolicyMap> policyMaps = new Vector<CertificatePolicyMap>();
             int num = getNumMappings();
 
             for (int i = 0; i < num; i++) {
diff --git a/pki/base/common/src/com/netscape/cms/profile/def/SubjectAltNameExtDefault.java b/pki/base/common/src/com/netscape/cms/profile/def/SubjectAltNameExtDefault.java
index c14f3239f2a9e99847e2758e8b4bcb32b93b4805..b205f7df481a30faf9cdc7339efa9b62f0331b1c 100644
--- a/pki/base/common/src/com/netscape/cms/profile/def/SubjectAltNameExtDefault.java
+++ b/pki/base/common/src/com/netscape/cms/profile/def/SubjectAltNameExtDefault.java
@@ -23,7 +23,6 @@ import java.util.Locale;
 import java.util.StringTokenizer;
 import java.util.UUID;
 
-import netscape.security.x509.GeneralName;
 import netscape.security.x509.GeneralNameInterface;
 import netscape.security.x509.GeneralNames;
 import netscape.security.x509.PKIXExtensions;
@@ -156,7 +155,7 @@ public class SubjectAltNameExtDefault extends EnrollExtDefault {
         super.setConfig(name, value);
     }
 
-    public Enumeration getConfigNames() {
+    public Enumeration<String> getConfigNames() {
         refreshConfigAndValueNames();
         return super.getConfigNames();
     }
@@ -354,13 +353,10 @@ public class SubjectAltNameExtDefault extends EnrollExtDefault {
                 GeneralNames names = (GeneralNames)
                         ext.get(SubjectAlternativeNameExtension.SUBJECT_NAME);
                 StringBuffer sb = new StringBuffer();
-                Enumeration e = names.elements();
+                Enumeration<GeneralNameInterface> e = names.elements();
 
                 while (e.hasMoreElements()) {
-                    Object o = (Object) e.nextElement();
-                    if (!(o instanceof GeneralName))
-                        continue;
-                    GeneralName gn = (GeneralName) o;
+                    GeneralNameInterface gn = e.nextElement();
 
                     if (!sb.toString().equals("")) {
                         sb.append("\r\n");
